



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android之使用MediaMetadataRetriever类获取媒体信息</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android之使用MediaMetadataRetriever类获取媒体信息</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 02:35:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>一.昨天。介绍了使用MediaMetadataRetriever类来获取视频第一帧：<a href="http://blog.csdn.net/u012561176/article/details/47858099" rel="external nofollow noreferrer">http://blog.csdn.net/u012561176/article/details/47858099</a>，今天，来介绍一下使用MediaMetadataRetriever类获取媒体信息。</p>
<p><div>&#65279;&#65279;1.当中用到了MediaMetadataRetriever类的无參构造函数：MediaMetadataRetriever()</div>
<p>2.当中用到了MediaMetadataRetriever类的一些经常用法：setDataSource(String&nbsp;path)或者其他參数的setDataSource()方法。以及返回字符串的extractMetadata(int keyCode)方法。</p>
<p>注：这里的extractMetadata(int keyCode)方法中的keyCode參数能够由MediaMetadataRetriever类的常量来得到，比如MediaMetadataRetriever.METADATA_KEY_ALBUM。</p>
<p>3.当中用到了MediaMetadataRetriever类的常量，这里我仅仅附上一部分常量的图：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150823102605022"></p>
<p>剩余的常量大家能够自行查看API文档，也能够通过 <a href="http://android.toolib.net/reference/android/media/MediaMetadataRetriever.html" rel="external nofollow noreferrer">http://android.toolib.net/reference/android/media/MediaMetadataRetriever.html</a>&nbsp;这个链接来查看，上述常量都是用在setDataSource方法之后的，然后通过extractMetadata(int keyCode)&nbsp;方法来返回一个字符串类型的媒体信息，当中KeyCode即为上述MediaMetadataRetriever类的常量。</p>
<p>二.接下来附上一个小样例，在编写这个样例之前，要做以下三个步骤：</p>
<p>1.开启Android模拟器。</p>
<p>2.打开File&nbsp;Explorer视图。</p>
<p>3.将音乐文件放入到/storage/sdcard/Music底下，当中要注意假设你的SD卡存储位置，Android2.x的为/mnt/sdcard或者/sdcard，Android4.x为/storage/sdcard，放置成功后例如以下图所看到的：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150823104619860?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"></p>
<p>三.最后。就能够编写我们这个Android小样例了，项目名为android_mediaMetadataRetriever1：</p>
<p>1.首先，进行布局，打开activity_main.xml布局文件，当中用的是垂直的线性布局。加入了七个TextView控件和一个Button控件，代码例如以下：</p>
<p><pre class="prettyprint linenums">&lt;LinearLayout xmlns:android=&quot;http://schemas.android.com/apk/res/android&quot;<br />
    xmlns:tools=&quot;http://schemas.android.com/tools&quot;<br />
    android:layout_width=&quot;match_parent&quot;<br />
    android:layout_height=&quot;match_parent&quot;<br />
    android:orientation=&quot;vertical&quot; &gt;

    &lt;TextView<br />
        android:id=&quot;@+id/ablum&quot;<br />
        android:layout_width=&quot;match_parent&quot;<br />
        android:layout_height=&quot;wrap_content&quot;<br />
        android:padding=&quot;5dp&quot;<br />
        android:text=&quot;哈哈&quot;<br />
        android:textSize=&quot;20sp&quot; /&gt;

    &lt;TextView<br />
        android:id=&quot;@+id/artist&quot;<br />
        android:layout_width=&quot;match_parent&quot;<br />
        android:layout_height=&quot;wrap_content&quot;<br />
        android:padding=&quot;5dp&quot;<br />
        android:text=&quot;哦哦&quot;<br />
        android:textSize=&quot;20sp&quot; /&gt;

    &lt;TextView<br />
        android:id=&quot;@+id/title&quot;<br />
        android:layout_width=&quot;match_parent&quot;<br />
        android:layout_height=&quot;wrap_content&quot;<br />
        android:padding=&quot;5dp&quot;<br />
        android:text=&quot;嗯嗯&quot;<br />
        android:textSize=&quot;20sp&quot; /&gt;

    &lt;TextView<br />
        android:id=&quot;@+id/mimetype&quot;<br />
        android:layout_width=&quot;match_parent&quot;<br />
        android:layout_height=&quot;wrap_content&quot;<br />
        android:padding=&quot;5dp&quot;<br />
        android:text=&quot;嘿嘿&quot;<br />
        android:textSize=&quot;20sp&quot; /&gt;

    &lt;TextView<br />
        android:id=&quot;@+id/duration&quot;<br />
        android:layout_width=&quot;match_parent&quot;<br />
        android:layout_height=&quot;wrap_content&quot;<br />
        android:padding=&quot;5dp&quot;<br />
        android:text=&quot;呃呃&quot;<br />
        android:textSize=&quot;20sp&quot; /&gt;

    &lt;TextView<br />
        android:id=&quot;@+id/bitrate&quot;<br />
        android:layout_width=&quot;match_parent&quot;<br />
        android:layout_height=&quot;wrap_content&quot;<br />
        android:padding=&quot;5dp&quot;<br />
        android:text=&quot;啊啊&quot;<br />
        android:textSize=&quot;20sp&quot; /&gt;

    &lt;TextView<br />
        android:id=&quot;@+id/date&quot;<br />
        android:layout_width=&quot;match_parent&quot;<br />
        android:layout_height=&quot;wrap_content&quot;<br />
        android:padding=&quot;5dp&quot;<br />
        android:text=&quot;噢噢&quot;<br />
        android:textSize=&quot;20sp&quot; /&gt; 

    &lt;Button<br />
        android:id=&quot;@+id/button&quot;<br />
        android:layout_width=&quot;match_parent&quot;<br />
        android:layout_height=&quot;wrap_content&quot;<br />
        android:text=&quot;获取音乐信息&quot; /&gt;

&lt;/LinearLayout&gt;</pre></p>
<p>2.接着，開始编写我们的MainActivity类，点击上述布局的button控件，把获取到的媒体信息显示在7个TextView控件，代码例如以下：</p>
<pre class="prettyprint linenums">package com.android_mediametadataretriever1;

import java.io.File;

import android.app.Activity;<br />
import android.media.MediaMetadataRetriever;<br />
import android.os.Bundle;<br />
import android.view.View;<br />
import android.view.View.OnClickListener;<br />
import android.widget.Button;<br />
import android.widget.TextView;

public class MainActivity extends Activity {

	private TextView ablum;//声明TextView对象ablum<br />
	private TextView artist;//声明TextView对象ablum_artist<br />
	private TextView title;//声明TextView对象title<br />
	private TextView mimetype;//声明TextView对象mimetype<br />
	private TextView duration;//声明TextView对象duration<br />
	private TextView bitrate;//声明TextView对象bitrate<br />
	private TextView date;//声明TextView对象date<br />
	private Button button;//声明Button对象button

	@Override<br />
	protected void onCreate(Bundle savedInstanceState) {<br />
		super.onCreate(savedInstanceState);<br />
		setContentView(R.layout.activity_main);<br />
		/*获取布局管理器中的控件*/<br />
		ablum = (TextView) findViewById(R.id.ablum);<br />
		artist=(TextView)findViewById(R.id.artist);<br />
		title=(TextView)findViewById(R.id.title);<br />
		mimetype=(TextView)findViewById(R.id.mimetype);<br />
		duration=(TextView)findViewById(R.id.duration);<br />
		bitrate=(TextView)findViewById(R.id.bitrate);<br />
		date=(TextView)findViewById(R.id.date);<br />
		button = (Button) findViewById(R.id.button);<br />
		//加入按钮点击事件监听器<br />
		button.setOnClickListener(new OnClickListener() {

			@Override<br />
			public void onClick(View v) {<br />
				// TODO Auto-generated method stub<br />
				MediaMetadataRetriever mmr=new MediaMetadataRetriever();//实例化MediaMetadataRetriever对象mmr<br />
				File file=new File(&quot;/storage/sdcard/Music/music1.mp3&quot;);//实例化File对象file，指定文件路径为/storage/sdcard/Music/music1.mp3<br />
				mmr.setDataSource(file.getAbsolutePath());//设置mmr对象的数据源为上面file对象的绝对路径<br />
				String ablumString=mmr.extractMetadata(MediaMetadataRetriever.METADATA_KEY_ALBUM);//获得音乐专辑的标题<br />
				String artistString=mmr.extractMetadata(MediaMetadataRetriever.METADATA_KEY_ARTIST);//获取音乐的艺术家信息<br />
				String titleString=mmr.extractMetadata(MediaMetadataRetriever.METADATA_KEY_TITLE);//获取音乐标题信息<br />
				String mimetypeString=mmr.extractMetadata(MediaMetadataRetriever.METADATA_KEY_MIMETYPE);//获取音乐mime类型<br />
				String durationString=mmr.extractMetadata(MediaMetadataRetriever.METADATA_KEY_DURATION);//获取音乐持续时间<br />
				String bitrateString=mmr.extractMetadata(MediaMetadataRetriever.METADATA_KEY_BITRATE);//获取音乐比特率。位率<br />
				String dateString=mmr.extractMetadata(MediaMetadataRetriever.METADATA_KEY_DATE);//获取音乐的日期<br />
				/* 设置文本的内容 */<br />
				ablum.setText(&quot;专辑标题为：&quot;+ablumString);<br />
				artist.setText(&quot;艺术家名称为：&quot;+artistString);<br />
				title.setText(&quot;音乐标题为：&quot;+titleString);<br />
				mimetype.setText(&quot;音乐的MIME类型为：&quot;+mimetypeString);<br />
				duration.setText(&quot;duration为：&quot;+durationString);<br />
				bitrate.setText(&quot;bitrate为：&quot;+bitrateString);<br />
				date.setText(&quot;date为：&quot;+dateString);<br />
			}<br />
		});<br />
	}

}
</pre>
<p>3.最后。由于我们是通过訪问文件sd卡的路径来设置数据源的。所以，必须在AndroidManifest.xml声明文件加入以下的许可，即权限：</p>
<pre class="prettyprint linenums">&lt;uses-permission android:name=&quot;android.permission.READ_EXTERNAL_STORAGE&quot;/&gt;</pre>
<p>注：当中必须注意的是使用MediaMetadataRetriever类要求android的minSdkVersion最小为14。所以假设你的AndroidManifest.xml文件里的android:minSDKVersion=&quot;8&quot;即最小的sdk版本号小于14的话，将会报错。解决的方法能够在AndroidManifest.xml文件里改最小sdk版本号，也能够在MainActivity类中加上以下的代码：
<pre class="prettyprint linenums">@TargetApi(Build.VERSION_CODES.ICE_CREAM_SANDWICH)</pre>
<p>使得我们使用这个MediaMetadataRetriever类不会报错。</p>
<p>四，部署此项目到Android模拟器上，执行效果例如以下：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150823110325797?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"></p>
<p>点击获取音乐信息button时。例如以下图所看到的：</p>
<p><img>
<p>watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"&gt;</p>
<p>这样媒体信息将获取出来了，当中有些媒体信息没有的，将为空。</p>
<p>五.以上内容仅供大家学习參考。写得不好。请见谅。如有错误，请指出，谢谢！</p>
<div>&#65279;&#65279;</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdeo09d.html">Windows平台分布式架构实践 - 负载均衡</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r7wm80.html">在CentOS上构建&period;net自动化编译环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvvwp1q.html">C&num;的接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql17o69.html">OpenStack 行业正进入拓展期：行业云将成为新一轮工业革命的基础设施和引擎</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxod6dq.html">（转）百度编辑器java使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1wzx69.html">180分钟的python学习之旅</a>
		</li>
						<li><a href="https://www.batexi.com/a/49570m0q.html">Socket实现仿QQ聊天（可部署于广域网）附源码（1）-简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv3ywj8.html">jquery多次上传同一张图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/49godvzq.html">关于html标签和属性的基本理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvx57j8.html">不错的linux下通用的java程序启动脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw7jgy8.html">Servlet 编程 http请求类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vrr7j8.html">python psutil 模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnd6lz8.html">JVM 类型的生命周期学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1dldx8.html">IIS7 ASP&period;NET 未被授权访问所请求的资源</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmvnd09.html">sizeof和strlen小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xyd3e8.html">Ubuntu 12&period;04 和 Win7 双系统安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm0d309.html">wampserver 2&period;4 配置虚拟主机</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlllyj1q.html">vsCode  列选择、列选中、选中列、选中多列（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwd7y79.html">Navicat for Mysql连接mysql数据库时出现 2003-Can&amp;&num;39&semi;t connect to MySql server on &amp;&num;39&semi;localhost&amp;&num;39&semi;&lpar;10061&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd6nyd9.html">VS 2017常用快捷键</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pd2ylk9.html">Vim常用操作-Nginx配置文件批量加注释。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj4yvk8.html">Linux ext2文件系统之初步思考</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geryg48.html">Servlet编程实例1</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj4zg38.html">OpenTSDB - 分布式可扩展的监控系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoennnq.html">git 分支合并 强制合并</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyrgde9.html">Javascript日期类型的妙用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z0rne9.html">Python 爬虫练习&lpar;一&rpar; 爬取国内代理ip</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1360xq.html">OC面向对象的三大特性</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojl7jxq.html">gulp  小坑一个</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kprwgj9.html">分布式监控系统Zabbix3&period;2给异常添加邮件报警</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
